﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=7.3
@EndOfDesignText@
'Code module
'Subs in this code module will be accessible from all modules.
Sub Process_Globals

End Sub


Sub Inizialize

End Sub

' imposto i colori delle caselle di testo
Sub SetEditTextColors(ctrl As EditText, bReadOnly As Boolean)
	'sfondo
	ctrl.Color		=	Colors.White 'Colors.LightGray 'Colors.RGB(255, 255, 204)
	'testo
	ctrl.TextColor	=	Colors.Black
	
	' stato 
	ctrl.Enabled	=	bReadOnly
	
End Sub

' imposto i colori degli spinner
Sub SetSpinnerColors(ctrl As Spinner, bReadOnly As Boolean)
	'sfondo
	ctrl.Color		=	Colors.LightGray 'Colors.RGB(255, 255, 204)
	'testo
	ctrl.TextColor	=	Colors.Black
	
	' stato 
	ctrl.Enabled	=	bReadOnly
End Sub

Sub SetReadOnlyText(ctrl As EditText, bReadOnly As Boolean)
	ctrl.Enabled	=	bReadOnly
End Sub
Sub SetReadOnlySpinner(ctrl As Spinner, bReadOnly As Boolean)
	ctrl.Enabled	=	bReadOnly
End Sub


' imposto i colori delle list view uguali
Sub SetListView2lbBMPTextColor(lv As ListView)

	lv.TwoLinesAndBitmap.Label.TextColor		= Colors.Black
	lv.TwoLinesAndBitmap.SecondLabel.TextColor	= Colors.RGB(110,113,115)

End Sub
' imposto i colori delle list view uguali
Sub SetListView2lbTextColor(lv As ListView)

	lv.TwoLinesLayout.Label.TextColor		= Colors.Black
	lv.TwoLinesLayout.SecondLabel.TextColor	= Colors.RGB(110,113,115)

End Sub
Sub SetListViewSingleLabelTextColor(lv As ListView)

	lv.SingleLineLayout.Label.TextColor		= Colors.Black

End Sub

' blocca l'orientamento del dispositivo
' utile per evitare che nella rotazione si perdano i dati
Sub FreezeOrientation
	' non usare perchè con tablet da grossi problemi: continua a girare il display
	Return
	
	Dim Orient As Int
	Dim DeviceOrientation As Int = GetOrientation
	
	Log("Device Orientation: " & DeviceOrientation)
	
    Select DeviceOrientation
        Case 0
            Orient = 1            'Portrait
        Case 1
            Orient = 0            'Landscape
        Case 2
            Orient = 9            'Reverse Portrait
        Case 3
            Orient = 8            'Reverse Landscape
    End Select
	
	Log("Orientamento: " & Orient)
	
	Dim PH As Phone
    PH.SetScreenOrientation(Orient)
	
	
End Sub
' sblocca la rotazione
Sub ReleaseOrientation
'	Dim PH As Phone
 '   PH.SetScreenOrientation(-1)

End Sub

Sub GetOrientation As Int
  Dim r As Reflector
  r.Target = r.GetContext
  r.Target = r.RunMethod2("getSystemService", "window", "java.lang.String")
  r.Target = r.RunMethod("getDefaultDisplay")
  Return r.RunMethod("getRotation")
End Sub

' imposto la proprietà della linea singola per la label 
' non disponibile nativamente in B4A
Sub SetSingleLineLabel(aLabel As Label, aValue As Boolean)

	Dim ref As Reflector
	ref.Target = aLabel
	ref.RunMethod2("setSingleLine", aValue, "java.lang.boolean")
	
End Sub

' imposta il valore multiriga o singola riga
Sub SetSingleLineEditText(aEdit As EditText, aValue As Boolean)

	Dim ref As Reflector
	ref.Target = aEdit
	ref.RunMethod2("setSingleLine", aValue, "java.lang.boolean")
	
End Sub

' colore dell'applicazione fisso
Sub GetMenuSlideColor As Int 
	Return GetColorFromEsacedimal("#B5E002") 'nuovo colore blu 29/11/18 '("#B0BEC5") verde
End Sub

' dimensione del device per la gestione minimiale 
Sub GetSizeMin As Double
	' dimensione minima dello schermo
	Return 8.0 
End Sub

' ok se è un schermo piccolo e in verticale, lo schermo piccolo in orizzontale si comporta come
' il tablet
public Sub WidhtIconToolbar As Boolean
	
	Dim aOrientation As Int	=	GetOrientation
	
	If  GetDevicePhysicalSize < GetSizeMin  And aOrientation = 0 Then
		Return True
	End If
	
	Return False
	
End Sub

' funzione temporanea per gestire la visualizzazione delle versioni intermedie
public Sub IsBigDevice As Boolean
	Return GetDevicePhysicalSize > GetSizeMin
End Sub

' identifico il tipo di dispositivo sul quale gira la app
' mettere in libreria
Sub GetTypeHardware() As String
	
	Dim val 			As String
	Dim aScreen 	As Double =	GetDeviceLayoutValues.ApproximateScreenSize
	
'	Log("Altezza: " & GetDeviceLayoutValues.Height)
'	Log("larghezza: " & GetDeviceLayoutValues.Width)
'	Log("dimensione: " & GetDeviceLayoutValues.ApproximateScreenSize)
'	Log("Scala: " & GetDeviceLayoutValues.Scale)
'	Log("To string " & GetDeviceLayoutValues.toString)
	
	If aScreen < 5.7 Then ' smartphone
		val = "phone"
	'Else If aScreen > 5.0 And aScreen < 10.0 Then ' tablet
	Else If aScreen >= 7.5 Then ' tablet - 10-3-16 - c'è il tablet note 3 che è inferiore a 10''.
		val = "tablet"
	Else If aScreen > 5.7 And aScreen <= 7.4 Then ' tablet
		val = "BigPhone"
	Else
		val = "other"
	End If
		
'	Log(val)
'	ToastMessageShow("Tipo dispositivo: " & val & " Dimensione " & aScreen, True)
	
	Return val
	
End Sub

'Exemple:
'<code>DeviceSize = Scale.GetDevicePhysicalSize</code>
Public Sub GetDevicePhysicalSize As Float
	
	Dim lv As LayoutValues

	lv = GetDeviceLayoutValues
			
'	Msgbox(lv.ApproximateScreenSize, "dimesione schermo")
	
	Dim aSize As Float = Sqrt(Power(lv.Height / lv.Scale / 160, 2) + Power(lv.Width / lv.Scale / 160, 2))
	
'	Msgbox(aSize, "Dimensione calcolata")
'	Log("dimensione e risoluzione schermo: " & aSize)
	
	Return aSize
	
End Sub



' restituisce la scala del device
Public Sub GetDeviceScale As Float
	
	Dim lv As LayoutValues = GetDeviceLayoutValues
	Return lv.Scale
	
End Sub

' restituisce il tag html per il wait
' TODO: centrare verticale
Public Sub GetHtmlWait As String
		Return "<html><body> <div style='text-align: center'>Caricamento in corso.....</div></body></html>"
End Sub

' restituisce il colore di sfondo della dashboard 
Sub GetBackGroundColorDashboard As Int
	
	Dim colorName As String = "#EEEEEE"' "#B5E000" ' verde chiaro
	
	Return GetColorFromEsacedimal(colorName)

End Sub

' restituisce il colore della app impostato nel manifest editor
Sub GetPrimaryColorApp As Int
		Dim ac As AppCompat
		Return  	ac.GetThemeAttribute("colorPrimary")
End Sub

' converto il colore in formato esadecimale in intero
Sub GetColorFromEsacedimal(aColor As String) As Int
	
	If aColor.Length < 7 Then
		LogColor("La lunghezza del colore deve essere di 7 caratteri", Colors.Red)
		Return 0
	End If

	Dim R = Bit.ParseInt(aColor.SubString2(1, 3), 16) As Int
  Dim G = Bit.ParseInt(aColor.SubString2(3, 5), 16) As Int
  Dim B = Bit.ParseInt(aColor.SubString2(5, 7), 16) As Int

 	Return Colors.RGB(r,g, b)
	
End Sub

' restituisce la dimensione dello schermo 
Sub GetDeviceSize As Double
	Return GetDeviceLayoutValues.ApproximateScreenSize
End Sub

' Restituisce la bitmap per la ricerca
Sub GetIconSearch As Bitmap
	Return LoadBitmap(File.DirAssets, "img/search_trasparent.png")
End Sub

Sub GetIconAddNew As Bitmap
	Return LoadBitmap(File.DirAssets, "img/new-trasparent.png")
End Sub

' icona duplicazione documento
Public Sub GetIconCopy As Bitmap
	Return LoadBitmap(File.DirAssets, "img/copy_trasparent.png")
End Sub



' restituisce l'altezza degli elementi della dashboard in funzione della scala e posizione del device
' il tutto in funzione del numero degli elementi da visualizzare 
Public Sub GetHeightItemDashBoard(aNumItems As Int) As Double
	
	Dim aScala As Float						= 	GetDeviceScale
	Dim aLayout As LayoutValues		=		GetDeviceLayoutValues
	Dim aIsLandscape As Boolean		=  	aLayout.Height >	aLayout.Width ' verticale
	Dim aHeightArea	As Int
	
	
'	Log("Scala: " & aScala)
'	Log("Is Landscape " & aIsLandscape)
'	Log("altezza " & aLayout.Height & " Larghezza " & aLayout.Width)
'	Log("Dimensione " & aLayout.ApproximateScreenSize)
	
	Select Case aScala
		
		Case 1
			aHeightArea = 60
			
		Case 2
			aHeightArea = 90
			
			If aIsLandscape Then aHeightArea = 50
			
		Case 3
			aHeightArea = 120
			
			If aIsLandscape Then aHeightArea = 140
			
		Case 4
			aHeightArea = 160
			
			If aIsLandscape Then aHeightArea = 200
		
		
	End Select
	
	Dim aHeightItem	As Int		=	DipToCurrent(aHeightArea)
	Dim height As Double			=	Max(aNumItems * aHeightArea, 100%y)
	
'	Log("Height area  " & aHeightArea)
'	Log("Height item " & height)
	
	Return height
	
End Sub


' disegno un bordo nel pannello, perchè è una funzionalità prevista solo nel Designer
Public Sub DrawBorderToPanel(aPanel As Panel)
	
	' disgno il bordo di un pannello via codice
	Dim cnv As Canvas
	cnv.Initialize(aPanel)
	Dim Path1 As Path
	Path1.Initialize(0, 0)
	Path1.LineTo(aPanel.Width, 0)
	Path1.LineTo(aPanel.Width, aPanel.Height)
	Path1.LineTo(0,aPanel.Height)
	Path1.LineTo(0,0)
	cnv.DrawPath(Path1, Colors.Black, False, 5dip)
	aPanel.Invalidate
	
End Sub