﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=7.3
@EndOfDesignText@
'Class module

#Event: EnterPressed
#Event: FocusChanged (HasFocus As Boolean)
#Event: TextChanged (Old As String, New As String)

' proprietà per estendere le funzionalità del controllo 
#DesignerProperty: Key: ShowEditor, 				DisplayName: Show Editor, FieldType: Boolean, DefaultValue: true
#DesignerProperty: Key: Multilinee, 				DisplayName: Multi Line, 				FieldType: Boolean, DefaultValue: true
#DesignerProperty: Key: FieldDescription, 	DisplayName: Edit Description, 	FieldType: String, 	DefaultValue: 



Sub Class_Globals
   Private mTarget As Object
   Private mEventName As String
   
  Private mEdit As EditText
 	'Private mEdit As ACEditText
	
	Private mData As String	' contiene il dato del controllo, da usare elaborare il dato e non usare il valore di text
	Private mFieldName As String ' nome del campo del db corrispondente
	Private mIsModified As Boolean
	Private mIsEdit As Boolean
	Private mIsDirty As Boolean	' indica che il controllè cambiato e che deve essere aggiornato nel database
	Private mHasFocus As Boolean
	 
	Private mIsUpper As Boolean
  Private mMaxLength As Int
  Private mMinValue, mMaxValue As Int
  Private mForceValues As Boolean ' forza il blocco sui valori da inserire nel controllo
	Private mColor, mTextColor As Int
	
	' gestione dinamica dell'altezza del controllo: utile per quando lavoro con smartphone ed il campo contiene info lunghe (ragione sociale)
	Private mCtrlHeight As Int
	
	' 10/11/2018 - gestione editor esteso
	Private mShowEdit 			As Boolean 	= False
	Private mWidhtBtnShow 	As Int			= 50dip
	Private mFieldDescr			As String	' descrizione del campo per editor
	Private mMultilinee			As Boolean
	
End Sub

Public Sub Initialize (TargetModule As Object, EventName As String)
  
	 mTarget 						= 	TargetModule
   mEventName 				= 	EventName
	 
   mEdit.Initialize("mEdit")
	 mTextColor					=			Colors.Black
		 
End Sub

Public Sub DesignerCreateView(Base As Panel, Lbl As Label, Props As Map)
	
	mEdit.Initialize("mEdit")
	 
	If Props.ContainsKey("ShowEditor") Then
		mShowEdit			= Props.Get("ShowEditor")
	Else
		LogColor("Proprietà ShowEditor non trovata nel controllo " & mEventName, Colors.Red)
	End If
	
	
	If mShowEdit Then
			
		Dim aWidht As Int = Base.Width - mWidhtBtnShow
		
'		Log("larghezza calcolata " & aWidht & " controllo = " & mEventName )
		
		Base.AddView(mEdit, 0,0, aWidht, Base.Height)
		
		If Props.ContainsKey("FieldDescription") Then
			mFieldDescr				=	Props.Get("FieldDescription")
		Else
			LogColor("Proprietà mFieldDescr non trovata nel controllo " & mEventName, Colors.Red)
		End If
	
			
		' visualizzo i pulsanti
		showEditText(Base, Lbl)
		
	Else
		Base.AddView(mEdit, 0,0, Base.Width , Base.Height)
	End If

	' trasferisco le proprietà del controllo al controll embedded	
	mEdit.Gravity					=		Lbl.Gravity
	mEdit.Typeface				=		Lbl.Typeface
	mEdit.Tag							=		Lbl.Tag
	
	mEdit.Text						=		Lbl.Text	
	mEdit.Enabled					=		Lbl.Enabled

	mEdit.TextColor				=		Lbl.TextColor
	mEdit.TextSize				=		Lbl.TextSize

	mEdit.Tag							=		Lbl.Tag
	mFieldName						=		mEdit.Tag	
	
	mTextColor 						= 	mEdit.TextColor
	
	If Props.ContainsKey("Multilinee") Then
		mMultilinee					= 	Not(Props.Get("Multilinee"))
		mEdit.SingleLine 		=		mMultilinee
	Else
		mEdit.SingleLine 			= True ' utile per evitare che il testo vada a capo, rendendolo illegibile
	End If
	
End Sub




#Region ShowEditor


Private Sub showEditText(Base As Panel, Lbl As Label)
	
	Dim aBtn As Button
	aBtn.Initialize("ShowEdit")
'	aBtn.Color = Colors.Red
		
	aBtn.SetBackgroundImage(LoadBitmapResize(File.DirAssets, "ic_more_horiz_black_48dp.png", mWidhtBtnShow / 2,mWidhtBtnShow / 2, True)).Gravity = Gravity.CENTER
	Base.AddView(aBtn, Base.Width - mWidhtBtnShow , 0dip , mWidhtBtnShow , mWidhtBtnShow )'Base.Height)
	
End Sub

' visualizzo il menu
Private Sub ShowEdit_Click
	
	ShowEditor
End Sub

' visualizza editor 
Private Sub ShowEditor
	
	Msgbox("show editor", "Show")
	
End Sub





#End Region
